<?php
// Notese que hay encabezados adicionales (DOCTYPE, html, meta). En principio no ponerlos no es un agujero de seguridad.
// Pero es buena costumbre porque le proporcionamos al navegador informacion de como interpretar el HTML de la pagina.
// En concreto, IE puede tener problemas (aprovechables) si no explicitamos Content-Type y charset.
$output = "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n";
$output .= "<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"es\" lang=\"es\" >\n";
$output .= "<head>\n";
$output .= "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />\n";
$output .= "</head>\n";
$output .= "<body>\n";

session_start();

// Es buena costumbre inicializar todas las variables explicitamente. Alguien puede cambiar el programa mas adelante
// y utilizar la variable inadecuada en el contexto inadecuado, asi que mejor prevenir
// Respecto al $_POST y al $_GET en principio ninguno es mas seguro que otro, aunque conviene saber de donde vienen
// los datos. En este caso no lo hacemos para permitir mas flexibilidad en los parametros....
$accion = !empty($_REQUEST['accion']) ? $_REQUEST['accion'] : NULL;
$login = !empty($_REQUEST['login']) ? $_REQUEST['login'] : NULL;
$password = !empty($_REQUEST['password']) ? $_REQUEST['password'] : NULL;
$clave = !empty($_REQUEST['clave']) ? $_REQUEST['clave'] : NULL;

$usuario = !empty($_SESSION['usuario']) ? $_SESSION['usuario'] : '';

// Inicio de la página. Aqui esta el tema
$output .= "<h1>Bienvenido a CSI</h1>";
$output .= "<h2>Corto pero Sumamente Inseguro</h2>";

switch ($accion) {
  case 'reset':
  case 'logout':
    $_SESSION = array();
    print "<p>Reset!</p>\n";
    break;  
  case 'login':
    // Esta validacion era un poco chapucera. Notese que se podia iniciar sesion con 'usuario'/'inocente'
    // pero tambien con ''/'usuarioinocente' u otras opciones. Por si acaso...
    if ($login === 'usuario' && md5($login . $password) === 'dc09cfb6c1d3672e6f5081b0106d75a9') {      
      // Prevenir Session Fixation. Regeneramos la sesion al hacer un login.
      session_regenerate_id();
      $_SESSION['usuario'] = $usuario = $login;
      // Prevenir XSS. Filtramos strings antes de mostrar.  
      $output .=  "<p>Bienvenido " . htmlspecialchars($usuario) . "</p>";
    }
    else {
      // Prevenir XSS. Filtramos strings antes de mostrar.      
      $output .=  "<p>No se ha podido iniciar sesion para " . htmlspecialchars($login) . "</p>\n";
    }
    break;
  case 'accion':    
    // Prevenir CSRF. Comprobamos que los datos incluyen tambien nuestro token 'secreto'
    // En PHP, si no comprobamos el tipo de datos podemos tener problemas. Esta expresion es cierta: 'hola' == TRUE
    // Para prevenirlo, o bien comprobamos el tipo de datos o usamos '==='
    if ($usuario && $clave === token_secreto()) {
      // Si el atacante consigue hacer esto, estamos jodidos
      $output .= accion_potencialmente_desastrosa();
    }
    else {
      $output .=  "<p>Sigue jugando.</p>\n";
    }
    break;

}

// Aqui empezamos a imprimir la pagina. No se puede hacer antes porque en el caso de regenerar la sesion,
// esta accion envia cookies nuevas, lo que produce un error si ya hemos empezado a imprimir.
print $output;

// Prevenir XSS. Filtramos strings antes de mostrar. Este no seria estrictamente necesario, pero no debemos
// olvidar que el nombre del usuario normalmente es normalmente creado por el propio usuario al registrarse
print "<p>Hola " . htmlspecialchars($usuario) . "</p>";

// Imprimir mensajes de estado y formulario
print "\n<form>\n";
if (!empty($_SESSION['desastre'])){
  print "<h2>Game Over (Te han jodido!!)</h2>\n";
} 
elseif (!empty($_SESSION['usuario'])) {
  // Para prevenir CSRF todos los formularios / URLs que ejecuten una accion deben tener seguridad adicional
  // Asi que introducimos nuestro token secreto en el formulario, que luego validaremos 
  print '<input type="hidden" name="accion" value="accion" />';
  print '<input type="hidden" name="clave" value="' . token_secreto() .'" />';
  print '<input type="submit" value="Accion" />';
  print "<br /><br />\n";
  print '<a href="csi.php?accion=logout">Salir</a>';
}
else {
  print '<h2>Inicia sesi&oacute;n</h2>';
  print '<h2>Login:</h2><input type="text" name="login" size="100" value="' . htmlspecialchars($login) . '"/>';
  print '<h2>Password:</h2><input type="text" name="password" size="100" value="' . $password . '"/>';
  print '<input type="hidden" name="accion" value="login" />';
  print "<br /><br />\n";
  print '<input type="submit" value="Entrar" />';
}
print "</form>\n";

print '<p><a href="csi.php?accion=reset">Reset</a></p>';
print '<p><a href="csi.php">Inicio</a></p>';

// Pues eso, una accion potencialmente desastrosa para el usuario inocente
function accion_potencialmente_desastrosa() {  
  $_SESSION['desastre'] = 1;
  return "<p>Accion potencialmente desastrosa ejecutada. Ayyy!.</p>";
}

// Prevenir CSRF. Generamos un token 'secreto' para este usuario y esta sesion que usaremos mas adelante
function token_secreto() {
  return md5(session_id() . 'clavesecreta');
}

// Esto era informacion de depuracion, que siempre es un riesgo. Asi que la quitamos.
// En este caso concreto, al imprimir directamente las Cookies que vienen del navegador pueden pasar "cosas".

// Esto es solo alguna informacion util y para dar formato
/*
print "<br /><br /><br />";
print "<div><small>";
print "<h2>Variables de sesi&oacute;n</h2>\n";
print "<p><strong>SESSIONID</strong>:" . session_id() . "</p>\n";
print "<p><strong>Usuario:</strong>:" . $_SESSION['usuario'] . "</p>\n";
print "<h2>Cookies</h2>";
print "<pre>\n";
print_r($_COOKIE);
print "\n</pre>";
print "</small></div>";
*/
print "</body>";
print "</html>";
?>
